<?php

// QuickTicket 2.2.2 build:20090816

session_start();
require_once('bin/qti_init.php');
if ( !$oVIP->CanView('V4') ) HtmlPage(11);
include(Translate('qti_stat.php'));

// --------
// INITIALISE
// --------

$oSYS->output='print';

$strCSV = '';

$s = -1;   // section filter
$intYear = date('Y'); if ( intval(date('n'))<2 ) $intYear--; // year filter
$tag = ''; // tags filter
$tt = 'g'; // tab: g=global, gt=globaltrend, d=detail, dt=detailtrend
$ch = array('m','b','a','a'); // chart parameters
// [0] blocktime: m=month, q=quarter, d=10days 
// [1] graph type: b=bar, l=line, B=bar+variation, L=line+variation
// [2] graphics reals: a=actual, p=percent
// [3] trends reals: a=actual, p=percent

// --------
// SUBMITTED
// --------
  
if ( isset($_GET['y']) ) $intYear = intval($_GET['y']);
if ( isset($_GET['s']) ) $s = intval($_GET['s']);
if ( $s>=0 ) { $strSection = 'forum='.$s.' AND'; } else { $strSection=''; }
if ( isset($_GET['tag']) ) $tag = strip_tags($_GET['tag']);
  $strTags = '';
  if ( !empty($tag) )
  {
    if ( substr($tag,-1,1)==';' ) $tag = substr($tag,0,-1); 
    $arrTags = explode(';',$tag);
    $str = '';
    foreach($arrTags as $strTag)
    {
    if ( !empty($str) ) $str .= ' OR ';
    $str .= 'UPPER(tags) LIKE "%'.strtoupper($strTag).'%"';
    }
    if ( !empty($str) ) $strTags = ' ('.$str.') AND';
  }
if ( isset($_GET['tt']) ) $tt = strip_tags($_GET['tt']);
if ( isset($_GET['ch']) )
{
  $str = strip_tags($_GET['ch']);
  if ( strlen($str)>0 ) $ch['time'] = substr($str,0,1); // blocktime
  if ( strlen($str)>1 ) $ch['type'] = substr($str,1,1); // graph type
  if ( strlen($str)>2 ) $ch['value'] = substr($str,2,1); // value type
  if ( strlen($str)>3 ) $ch['trend'] = substr($str,3,1); // trends value type
}

// ------
// OUTPUT
// ------

$arrYears = array($intYear-1,$intYear); // Normal is 1 year but for Trends analysis, 2 years

include('qti_stats_inc.php');

$arr = GetSectionTitles($oVIP->role);
$strCSV .= '"'.($intYear-1).' '.$intYear.($s>=0 ? ' ('.$arr[$s].')' : '').(empty($tag) ? '' : ', '.$L['With_tag'].' '.str_replace(';',' '.$L['or'].' ',$tag)).'"<br/>';

// -----
foreach(array($intYear-1,$intYear) as $intYear) {
// -----

  // Table header

  $strCSV .= '"'.$intYear.'";';

  switch($ch['time'])
  {
  case 'q': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"Q'.$i.'";'; } break;
  case 'm': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"'.$L['dateMM'][$i].'";'; } break;
  case 'd': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"'.QTdatestr( DateAdd($strTendaysago,$i,'day'),'d M','' ).'";'; } break;
  }
  $strCSV .= '"'.($ch['time']=='d' ? '10 '.strtolower($L['Days']) : $L['Year']).'"<br/>';

  // Table body

  $strCSV .= '"'.$L['Topics'].'";';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) { $strCSV .= (isset($arrT[$intYear][$intBt]) ? $arrT[$intYear][$intBt] : '0').';'; }
  $strCSV .= $arrTs[$intYear].'<br/>';

  $strCSV .= '"'.$L['Replys'].'";';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) { $strCSV .= (isset($arrM[$intYear][$intBt]) ? $arrM[$intYear][$intBt] : '0').';'; }
  $strCSV .= $arrMs[$intYear].'<br/>';

  $strCSV .= '"'.$L['Users'].'";';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) { $strCSV .= (isset($arrU[$intYear][$intBt]) ? $arrU[$intYear][$intBt] : '0').';'; }
  $strCSV .= $arrUs[$intYear].'<br/><br/>';

// -----
}
// -----

  // Table header

  $strCSV .= '"'.$L['Trends'].'";';

  switch($ch['time'])
  {
  case 'q': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"Q'.$i.'";'; } break;
  case 'm': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"'.$L['dateMM'][$i].'";'; } break;
  case 'd': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"'.QTdatestr( DateAdd($strTendaysago,$i,'day'),'d M','' ).'";'; } break;
  }
  $strCSV .= '"'.($ch['time']=='d' ? '10 '.strtolower($L['Days']) : $L['Year']).'"<br/>';

  // Table body

  $strCSV .= $L['Topics'].';';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
  {
    $i = 0;
    if ( isset($arrT[$intYear][$intBt]) && isset($arrT[$intYear-1][$intBt]) )
    {
      $i = $arrT[$intYear][$intBt]-$arrT[$intYear-1][$intBt];
      if ( $ch['trend']=='p' && $i!=0 )
      {
        if ( $arrT[$intYear-1][$intBt]==0 ) $arrT[$intYear-1][$intBt]=1;
        $i = intval(($i/$arrT[$intYear-1][$intBt])*100);
      }
    }
    $strCSV .= $i.';';
  }
  $i = 0;
  if ( isset($arrTs[$intYear]) && isset($arrTs[$intYear-1]) )
  {
    $i = $arrTs[$intYear]-$arrTs[$intYear-1];
    if ( $ch['trend']=='p' && $i!=0 )
    {
      if ( $arrTs[$intYear-1]==0 ) $arrTs[$intYear-1]=1;
      $i = intval(($i/$arrT[$intYear-1])*100);
    }
  }
  $strCSV .= $i.'<br/>';

  $strCSV .= $L['Replys'].';';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
  {
    $i = 0;
    if ( isset($arrM[$intYear][$intBt]) && isset($arrM[$intYear-1][$intBt]) )
    {
      $i = $arrM[$intYear][$intBt]-$arrM[$intYear-1][$intBt];
      if ( $ch['trend']=='p' && $i!=0 )
      {
        if ( $arrM[$intYear-1][$intBt]==0 ) $arrM[$intYear-1][$intBt]=1;
        $i = intval(($i/$arrM[$intYear-1][$intBt])*100);
      }
    }
    $strCSV .= $i.';';
  }
  $i = 0;
  if ( isset($arrMs[$intYear]) && isset($arrMs[$intYear-1]) )
  {
    $i = $arrMs[$intYear]-$arrMs[$intYear-1];
    if ( $ch['trend']=='p' && $i!=0 )
    {
      if ( $arrMs[$intYear-1]==0 ) $arrMs[$intYear-1]=1;
      $i = intval(($i/$arrMs[$intYear-1])*100);
    }
  }
  $strCSV .= $i.'<br/>';

  $strCSV .= $L['Users'].';';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
  {
    $i = 0;
    if ( isset($arrU[$intYear][$intBt]) && isset($arrU[$intYear-1][$intBt]) )
    {
      $i = $arrU[$intYear][$intBt]-$arrU[$intYear-1][$intBt];
      if ( $ch['trend']=='p' && $i!=0 )
      {
        if ( $arrU[$intYear-1][$intBt]==0 ) $arrU[$intYear-1][$intBt]=1;
        $i = intval(($i/$arrU[$intYear-1][$intBt])*100);
      }
    }
    $strCSV .= $i.';';
  }
  $i = 0;
  if ( isset($arrUs[$intYear]) && isset($arrUs[$intYear-1]) )
  {
    $i = $arrUs[$intYear]-$arrUs[$intYear-1];
    if ( $ch['trend']=='p' && $i!=0 )
    {
      if ( $arrUs[$intYear-1]==0 ) $arrUs[$intYear-1]=1;
      $i = intval(($i/$arrU[$intYear-1])*100);
    }
  }
  $strCSV .= $i.'<br/>';

// Export

if ( !headers_sent() )
{
  $strCSV = str_replace('<br/>',"\r\n",$strCSV);
  header('Content-Type: text/csv; charset='.QTI_HTML_CHAR);
  header('Content-Disposition: attachment; filename="global_stat_'.$intYear.'.csv"');
}

echo $strCSV;

?>