<?php

// QuickTicket 2.2 build:20090816

function HtmlHead($strRoot='',$strSkin='',$arrCss='',$strHeadScript='',$bJava=true,$intBbc=0)
{

if ( empty($strSkin) ) $strSkin = $_SESSION[QT]['skin_dir'];
if ( !is_array($arrCss) ) $arrCss = array();

echo QTI_HTML_DTD,'
<html xmlns="http://www.w3.org/1999/xhtml" dir="',QTI_HTML_DIR,'" xml:lang="',QTI_HTML_LANG,'">
<head>
<title>',$_SESSION[QT]['site_name'],'</title>
<meta http-equiv="content-type" content="text/html; charset=',QTI_HTML_CHAR,'"/>
<link rel="shortcut icon" href="',$strRoot,$strSkin,'/qti_icon.ico"/>
<link rel="stylesheet" type="text/css" href="',$strRoot,$strSkin,'/qti_main.css" title="cssmain"/>
';
foreach($arrCss as $strCss) {
switch($strCss) {
  case 'qti_contrast.css': echo '<link rel="alternate stylesheet" type="text/css" href="',$strRoot,'bin/css/qti_contrast.css" title="cssalternate"/>',"\n"; break;
  case 'qti_main2.css':    echo '<link rel="stylesheet" type="text/css" href="',$strRoot,$strSkin,'/',$strCss,'" title="cssmain"/>',"\n"; break;
  default:
    if ( substr($strCss,0,6)=='[root]' )
    {
    echo '<link rel="stylesheet" type="text/css" href="',substr($strCss,6),'"/>',"\n";
    }
    else
    {
    echo '<link rel="stylesheet" type="text/css" href="',$strRoot,$strSkin,'/',$strCss,'"/>',"\n";
    }
    break;
}}

if ( !empty($strHeadScript) ) echo $strHeadScript;

if ( $intBbc>0 && $_SESSION[QT]['bbc']!='0' )
{
echo '<script type="text/javascript">
<!--
';
include($strRoot.'bin/qti_j_bbc.js');
echo '
-->
</script>
';
}
if ( $bJava )
{
echo '<script type="text/javascript">
<!--
';
include($strRoot.'bin/qti_j_common.js');
echo '
-->
</script>
';
}

echo '</head>
';

}

// --------

function HtmlPageCtrl($intType=0,$strWidth='90%')
{

switch ($intType)
{
case 0: echo '
<!-- PAGE CONTROL -->
<div class="qti_page">
<table class="qti_page" width="',$strWidth,'" cellspacing="0" cellpadding="0"><tr class="qti_page"><td class="qti_page">
<!-- PAGE CONTROL -->
';
break;
case 1: echo '
<!-- END PAGE CONTROL -->
</td></tr></table>
</div>
<!-- END PAGE CONTROL -->
';
break;
}

}

// --------

function HtmlBanner($intType=0,$strSkin='',$strLogo='',$strLangMenu='')
{

if ( empty($strSkin) ) $strSkin=$_SESSION[QT]['skin_dir'];
if ( empty($strLogo) ) $strLogo='qti_logo.gif';

switch ($intType)
{
case 0: echo '
<!-- HEADER BANNER -->
<div class="banner"><div class="banner_in">
<table class="hidden" cellspacing="0"><tr class="hidden">
<td class="hidden" id="banner_zl"><img id="banner_logo" src="',$strSkin,'/',$strLogo,'" alt="',$_SESSION[QT]['site_name'],'" title="',$_SESSION[QT]['site_name'],'"/></td>
<td class="hidden" id="banner_zr">',$strLangMenu,'</td>
</tr></table></div></div>
<!-- END HEADER BANNER -->
';
break;
case 1: echo '
<!-- HEADER NOBANNER -->
<table class="hidden" cellspacing="0"><tr class="hidden">
<td id="nobanner_zl">&nbsp;</td>
<td id="nobanner_zr">&nbsp;',$strLangMenu,'</td>
</tr></table>
<!-- END HEADER NOBANNER -->
';
break;
case 2: echo '
<!-- HEADER BANNER -->
<div class="banner">
<div class="banner_in">
<img src="',$strSkin,'/',$strLogo,'" width="150" height="50" style="border-width:0" alt="QuickTicket" title="QuickTicket"/>
</div>
</div>
<!-- END HEADER BANNER -->
';
break;
}

}

// --------

function HtmlLettres($strGroup,$str='All')
{
  global $oVIP;
  $strGroups = '<td class="lettres'.($strGroup=='all' ? ' active' : '').'" style="width:35px;">'.($strGroup=='all' ? $str : '<a class="lettres" href="'.$oVIP->selfurl.'?group=all">'.$str.'</a>' ).'</td>';
  for ($g='A';$g!='AA';$g++)
  {
  $strGroups .= '<td class="lettres'.($strGroup==$g ? ' active' : '').'" style="width:18px;">'.($strGroup==$g ? $g : '<a class="lettres" href="'.$oVIP->selfurl.'?group='.$g.'">'.$g.'</a>' ).'</td>';
  }
  $strGroups .= '<td class="lettres'.($strGroup=='0' ? ' active' : '').'" style="width:18px;">'.($strGroup=='0' ? '#' : '<a class="lettres" href="'.$oVIP->selfurl.'?group=0">#</a>' ).'</td>';
  return $strGroups.'<td class="hidden">&nbsp;</td>'.N;
}

// --------

function HtmlPage($e=0)
{

global $oSYS,$oVIP,$L;
include('qti_p_header.php');

if ( $e==99 )
{
$strFile = Translate('sys_offline.txt'); if ( file_exists($strFile) ) { include($strFile); } else { echo Error(10); }
}
else
{
HtmlMsg(0); echo Error($e); HtmlMsg(1);
}

include('qti_p_footer.php');
exit;

}

// --------

function HtmlMsg($intType=0,$strWidth='',$strTitleId='',$strTitle='!',$strBodyId='',$strBody='')
{

if ( empty($strWidth) ) $strWidth='350px';

switch ($intType)
{
case 0: echo '
<div class="msgbox" style="width:',$strWidth,'">
<div class="msgboxtitle"',(empty($strTitleId) ? '' : ' id="'.$strTitleId.'"'),'>',$strTitle,'</div>
<div class="msgboxbody"',(empty($strBodyId) ? '' : ' id="'.$strBodyId.'"'),'>',(empty($strBody) ? '' : $strBody),'
';
break;
case 1: echo '
</div>
</div>
';
break;
}

}

// --------

function HtmlTabs($arrTabs=array(0=>'Empty'),$strUrl='', $strCurrent='',$intMax=6,$bFirst=true,$bLast=true,$strWarning='Data not yet saved. Quit without saving?')
{

// tabx means the last tab (can be special due to popup)
// if defined, the class/style tab_on replaces the class/style tab (but you can cumulate the classes in the definition)
// if defined, the class/style tabx_on replaces the class/style tabx (but you can cumulate the styles in the definition)
// When strCurrent is defined, this tab will not be clickable
// $arrTabs can be an array of: strings, arrays, cTab


$iCurrent=1;
foreach(array_keys($arrTabs) as $strKey)
{
  if ($strKey==$strCurrent) break;
  $iCurrent++;
}

// check

if ( !is_array($arrTabs) ) die('HtmlTabs: Argument #1 must be an array');
if ( !empty($strUrl) ) { if ( !strstr($strUrl,'?') ) $strUrl .= '?'; }

// display

echo'
<!-- tab header begin -->
<table cellspacing="0" class="tab">
';

$strOuts=''; $strOut=''; $intRow=0; $intCol=0;
foreach($arrTabs as $strKey=>$oTab)
{
  if ( $intCol==0 )
  {
    $strOut = '<tr class="tab">'."\n";
    if ( $bFirst ) $strOut .= '<td class="tab '.($intRow==0 ? 'tab_begin' : 'tab_hidden').'">&nbsp;</td>'."\n";
    $intCol++;
  }
  if ( $intCol>0 )
  {
    $strTab = '';
    $strTabDesc = '';
    // extract name and description from the object in arrTabs: can be a string, an array or a cTab
    if ( is_string($oTab) )
    {
      $strTab = $oTab;
    }
    elseif ( is_array($oTab) )
    {
      if ( isset($oTab['tabdesc']) )
      {
        if ( !empty($oTab['tabdesc']) ) $strTabDesc = $oTab['tabdesc'];
      }
      if ( isset($oTab['tabname']) )
      {
        if ( !empty($oTab['tabname']) ) { $strTab=$oTab['tabname']; } else { $strTab=ObjTrans('tab',$strKey); }
      }
      else
      {
        $strTab=ObjTrans('tab',$strKey);
      }
    }
    elseif ( strtolower(get_class($oTab))=='ctab' )
    {
      $strTabDesc = $oTab->tabdesc;
      $strTab = $oTab->tabname; if ( empty($strTab) ) $strTab = $oTab->tabid;
    }
    else
    {
      die('HtmlTabs: Arg #1 must be an array of strings, arrays or cTab');
    }
    $strOut .= '<td class="tab tab_'.($strCurrent==$strKey ? 'on' : 'off').'_l">&nbsp;</td>';
    $strOut .= '<td class="tab tab_'.($strCurrent==$strKey ? 'on' : 'off').'_c">';
    if ( empty($strUrl) || $strCurrent==$strKey )
    {
    $strOut .=  $strTab;
    }
    else
    {
    $strOut .=  '<a class="tab" href="'.$strUrl.'&amp;tt='.$strKey.'"'.(empty($strTabDesc) ? '' : ' title="'.$strTabDesc.'"').' onclick="return qtEdited(bEdited,\''.$strWarning.'\');">'.$strTab.'</a>';
    }
    $strOut .= '</td>';
    $strOut .= '<td class="tab tab_'.($strCurrent==$strKey ? 'on' : 'off').'_r">&nbsp;</td>'."\n";
    $intCol++; 
  }
  if ( $intCol>$intMax || $intCol>count($arrTabs) )
  {
    if ( $bLast ) $strOut .= '<td class="'.($intRow==0 ? 'tab tab_end' : 'hidden').'">&nbsp;</td>'."\n";
    $strOut .= '</tr>'."\n";
    $intCol=0;
    $strOuts = $strOut.$strOuts;
    $intRow++;
  }
}
if ( $intCol>0 )
{
  while($intCol<=$intMax) { $strOut .= '<td class="tab tab_a">&nbsp;</td>'; $intCol++; }
  if ( $bLast ) $strOut .= '<td class="tab'.($intRow==0 ? ' tab_end' : ' tab_hidden').'">&nbsp;</td>'."\n";
  $strOut .= '</tr>';
  $strOuts = $strOut.$strOuts;
}
echo $strOuts;

echo '
</table>
<!-- tab header end -->
';

}

// --------

function TableHeader($arrFLD,$intCount=0,$strUrl='',$strOrder='lastpostdate',$strDir='')
{
  $img['ASC'] = ' <img class="ico i_sort" src="'.$_SESSION[QT]['skin_dir'].'/sort_asc.gif" alt="+"/>';
  $img['DESC']= ' <img class="ico i_sort" src="'.$_SESSION[QT]['skin_dir'].'/sort_desc.gif" alt="-"/>';
  
  foreach($arrFLD as $strKey=>$oFLD)
  {
    $arrOptions = ReadValues($oFLD->desc);
    // change the text to hyperlink+image when necessary
    if ( $oFLD->sort && $intCount>2 )
    {
      if ( $strKey==$strOrder )
      {
      $str = '<a href="'.$strUrl.'&amp;order='.$oFLD->uid.'&amp;dir='.QTinvert($strDir).'"'.(isset($arrOptions['class']) ? ' class="'.$arrOptions['class'].'"' : '').'>'.$oFLD->name.'</a>'.$img[$strDir];
      }
      else
      {
      $str = '<a href="'.$strUrl.'&amp;order='.$oFLD->uid.'&amp;dir='.$oFLD->sort.'"'.(isset($arrOptions['class']) ? ' class="'.$arrOptions['class'].'"' : '').'>'.$oFLD->name.'</a>';
      }
    }
    else
    {
    $str = $oFLD->name;
    }
    echo '<td',(isset($arrOptions['class']) ? ' class="'.$arrOptions['class'].'"' : ''),(isset($arrOptions['style']) ? ' style="'.$arrOptions['class'].'"' : ''),'>',$str,'</td>',N;
  }
}

// ----------------

function TableRow($arrFLD,$row,$bTopic=false,$oSEC,$strAlt='r1',$bMap=false)
{

// SETUP
  
global $oVIP,$oSYS,$L,$arrExtData;
if ( $bTopic ) $oTopic = new cTopic($row);
if ( isset($arrFLD['numid']) ) { $strSectionNumfield='N'; if ( isset($oSEC) ) $strSectionNumfield=$oSEC->numfield; if ( isset($row['numfield']) ) $strSectionNumfield=$row['numfield']; }
if ( isset($arrFLD['smile']) ) { $strSectionPrefix=''; if ( isset($oSEC) ) $strSectionPrefix=$oSEC->prefix; if ( isset($row['prefix']) ) $strSectionPrefix=$row['prefix']; }
if ( isset($arrFLD['you']) && $oTopic->replies>0 )
{
  global $arrMe;
  if ( !empty($arrMe) ) {
  if ( array_key_exists($oTopic->id,$arrMe) ) {
  $oTopic->youreply = '<span title="'.$L['You_reply'].(empty($arrMe[$oTopic->id]) ? '' : ', '.QTdatestr($arrMe[$oTopic->id],'d M','H:i',true,true)).'"><b>&reg;</b></span>';
  }}
}
if ( isset($arrFLD['sectiontitle']) ) { if ( isset($oSYS->sections[$oTopic->section]) ) { $strSectiontitle = $oSYS->sections[$oTopic->section]; } else { $strSectiontitle='[section '.$oTopic->section.']'; } }
if ( isset($arrFLD['tags']) )
{
  $strTags = '';
  $strAbbr = '';
  if ( empty($oTopic->tags) ) { $arrTags=array(); } else { $arrTags=explode(';',$oTopic->tags); }
  if ( count($arrTags)>1 )
  {
    for ($i=0;$i<count($arrTags);$i++)
    {
      if ( $i<3 ) $strTags .= $arrTags[$i].';';
      if ( $i>=3 ) $strAbbr .= $arrTags[$i].';';
      if ( $i>13 ) break;
    }
  }
  else
  {
    $strTags = $oTopic->tags;
  }
  $strTags = str_replace(';',' ',$strTags.(empty($strAbbr) ? '' : '<abbr title="'.$strAbbr.'">...</abbr>'));
}

// when searching in posts without title, use this to report empty title
if ( isset($arrFLD['title']) )
{
  if ( trim($oTopic->title)=='' ) $oTopic->title='('.strtolower($L['Reply']).')';
  if ( empty($oTopic->title) && $oTopic->title!='0' ) $oTopic->title='('.strtolower($L['Reply']).')';
}

// icon
if ( isset($arrFLD['icon']) )
{
  if ( $oTopic->type=='A' )
  {
    $strTicon = $_SESSION[QT]['skin_dir'].'/ico_topic_a_0.gif';
    $strTname = $L['Ico_topic_a_0'];
  }
  else
  {
    if ( isset($oSYS->statuses[$oTopic->status]['statusname']) )
    {
    $strTicon = $_SESSION[QT]['skin_dir'].'/'.$oSYS->statuses[$oTopic->status]['icon'];
    $strTname = $oSYS->statuses[$oTopic->status]['statusname'];
    }
    else
    {
    $strTicon = 'admin/ico_status.gif';
    $strTname = 'unknown status';
    }
  }
}

// mail
if ( isset($arrFLD['mail']) || isset($arrFLD['location']) )
{
  $strMail = '<img class="ico i_user" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_e_0.gif" alt="mail" title="no e-mail"/>';
  if ( !empty($row['mail']) )
  {
  if ( $row['privacy']=='2' ) $strMail = AsEmails($row['mail'],$row['id'],'0','img'.(QTI_JAVA_MAIL ? 'java' : ''),false,$_SESSION[QT]['skin_dir'],'Java protected email','&nbsp;');
  if ( $row['privacy']=='1' && $oVIP->role!='V' ) $strMail = AsEmails($row['mail'],$row['id'],'0','img'.(QTI_JAVA_MAIL ? 'java' : ''),false,$_SESSION[QT]['skin_dir'],'Java protected email','&nbsp;');
  if ( $oVIP->id==$row['id'] || $oVIP->IsStaff() ) $strMail = AsEmails($row['mail'],$row['id'],'0','img'.(QTI_JAVA_MAIL ? 'java' : ''),false,$_SESSION[QT]['skin_dir'],'Java protected email','&nbsp;');
  }
}

// www
$strWww='';
if ( isset($arrFLD['www']) || isset($arrFLD['contact']) )
{
  if ( !empty($row['www']) ) $strWww = '<a href="'.$row['www'].'"><img class="ico" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_w_1.gif" alt="www" title="web site"/></a>';
}

// coord
$strCoord='';
$strLatLon='';
if ( $bMap && isset($row['y']) && isset($row['x']) )
{
  $y = floatval($row['y']);
  $x = floatval($row['x']);
  if ( !empty($y) && !empty($x) )
  {
    global $bMapGoogle;
    $strCoord = '<a href="javascript:void(0)"'.($bMapGoogle && !$_SESSION[QT]['m_map_hidelist'] ? ' onclick="map.setCenter(new GLatLng('.$y.','.$x.')); return false;"' : '').' title="'.$L['Coord'].': '.round($y,8).','.round($x,8).'"><img class="ico" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_m_1.gif" alt="G" title="'.$L['Coord_latlon'].' '.QTdd2dms($y).','.QTdd2dms($x).'"/></a>';
    $strLatLon = QTdd2dms($y).'<br/>'.QTdd2dms($x);
  }
}
if ( $bMap && empty($strCoord) ) $strCoord = '<img class="ico i_user" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_m_0.gif" alt="G" title="No coordinates"/>';

// map points

if ( $bMap ) {
if ( !empty($oTopic->y) && !empty($oTopic->x) ) {
  $str = AsImg($strTicon,'T',$strTname,'ico ico_t').' '.( $strSectionNumfield=='N' ? '' : sprintf($strSectionNumfield,$oTopic->numid) );
  $str .= '<p class="small">'.QTconv(substr($oTopic->title,0,50),'3',QTI_CONVERT_AMP);
  $str .= '<br/>'.$L['By'].' '.QTconv($oTopic->firstpostname).' ('.QTdatestr($oTopic->firstpostdate,'$','$',true,true).')<br/>'.LangS('Reply',$oTopic->replies);
  $str .= '<br/><a class="gmap" href="qti_topic.php?s='.$oTopic->section.'&amp;t='.$oTopic->id.'">'.$L['map']['View_ticket'].' &raquo;</a></p>';
  $oMapPoint = new cMapPoint( floatval($row['y']),floatval($row['x']),( $strSectionNumfield=='N' ? '' : sprintf($strSectionNumfield,$oTopic->numid).' ' ).substr($oTopic->title,0,25),$str );
  if ( isset($_SESSION[QT]['m_map'][$oTopic->section]['icon']) )        $oMapPoint->icon        = $_SESSION[QT]['m_map'][$oTopic->section]['icon'];
  if ( isset($_SESSION[QT]['m_map'][$oTopic->section]['shadow']) )      $oMapPoint->shadow      = $_SESSION[QT]['m_map'][$oTopic->section]['shadow'];
  if ( isset($_SESSION[QT]['m_map'][$oTopic->section]['printicon']) )   $oMapPoint->printicon   = $_SESSION[QT]['m_map'][$oTopic->section]['printicon'];
  if ( isset($_SESSION[QT]['m_map'][$oTopic->section]['printshadow']) ) $oMapPoint->printshadow = $_SESSION[QT]['m_map'][$oTopic->section]['printshadow'];
  $arrExtData[$oTopic->id] = $oMapPoint;
}}

// DISPLAY

switch($oSYS->output)
{

case 'screen':

  echo '<tr class="data_t ',$strAlt,'">',N;
  
  // ::::::::::
  foreach($arrFLD as $strKey=>$oFLD) {
  // ::::::::::

  $str = '&nbsp;';
  $arrOptions = ReadValues($oFLD->desc);
  $strClass = ''; if ( isset($arrOptions['class']) ) $strClass = ' class="'.$arrOptions['class'].' td_t_'.$strAlt.'"';
  $strStyle = ''; if ( isset($arrOptions['style']) ) $strStyle = ' style="'.$arrOptions['style'].'"';
  if ( !empty($strStyle) ) {
  if ( strstr($strStyle,'%bg') ) {
  if ( $strKey=='status' || $strKey=='numid' ) {
  $strStyle = str_replace('%bg',$oSYS->statuses[$oTopic->status]['color'],$strStyle);
  }}}

  switch ($strKey)
  {
  case 'icon': $str = AsImg($strTicon,'T',$strTname,'ico i_topic','','qti_topic.php?s='.$oTopic->section.'&amp;t='.$oTopic->id); break;
  case 'numid': $str = ( $strSectionNumfield=='N' ? '&nbsp;' : '<span class="span_ref">'.sprintf($strSectionNumfield,$oTopic->numid).'</span>' ); break;
  case 'smile': $str = ( $oTopic->smile=='00' ? '&nbsp;' : AsImg($_SESSION[QT]['skin_dir'].'/ico_prefix_'.$strSectionPrefix.'_'.$oTopic->smile.'.gif','[o]',$L['Ico_prefix'][$strSectionPrefix.'_'.$oTopic->smile],'ico ico_prefix') ); break;
  case 'title': $str = ( $oTopic->type=='A' ? '<span class="small">'.$L['News_stamp'].'</span>' : '' ).'<a class="topic" href="qti_topic.php?s='.$oTopic->section.'&amp;t='.$oTopic->id.'"'.(!empty($oTopic->preview) ? ' title="'.$oTopic->preview.'"' : '').'>'.$oTopic->title.'</a>'.( empty($strCoord) ? '' : ' '.$strCoord ); break;
  case 'you': $str = $oTopic->youreply; break;
  case 'replies': $str = $oTopic->replies; break;
  case 'sectiontitle': $str = ObjTrans('sec','s'.$oTopic->section,$strSectiontitle); break;
  case 'firstpostname': $str = '<a href="qti_usr.php?id='.$oTopic->firstpostuser.'" title="'.$L['Ico_user_p_1'].'" class="small">'.$oTopic->firstpostname.'</a><br/>'.QTdatestr($oTopic->firstpostdate,'$','$',true,true,true); break;
  case 'lastpostdate': $str = QTdatestr($oTopic->lastpostdate,'$','$',true,true,true).' <a href="qti_topic.php?s='.$oTopic->section.'&amp;t='.$oTopic->id.'#p'.$oTopic->lastpostid.'" title="'.$L['H_Goto_message'].'">'.$L['Goto_message'].'</a><br/>'.strtolower($L['By']).' <a href="qti_usr.php?id='.$oTopic->lastpostuser.'" title="'.$L['Ico_user_p_1'].'" class="small">'.$oTopic->lastpostname.'</a>'; break;
  case 'status': $str = '<span class="small" title="'.(empty($oTopic->statusdate) ? '' : QTdatestr($oTopic->statusdate,'d M','H:i',true,true)).'">'.$oSYS->statuses[$oTopic->status]['statusname'].'</span>'; break;
  case 'tags': $str = '<span class="tag small">'.$strTags.'</span>'; break;
  case 'photo': $str = ( empty($row['photo']) ? S : AsImg(QTI_DIR_PIC.$row['photo'],'',$row['name'],'imagelist','','qti_usr.php?id='.$row['id']) ); break;
  case 'name': $str = '<a href="qti_usr.php?id='.$row['id'].'">'.$row['name'].'</a>'; break;
  case 'role': $str = '<span class="small">'.$L['Userrole'][$row['role']].'</span>'; break;
  case 'contact': $str = ( empty($strMail) ? '<img class="ico" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_e_0.gif" alt="mail" title="no e-mail"/>' : $strMail ).' '.( empty($strWww) ? '<img class="ico" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_w_0.gif" alt="email" title="no web site"/>' : $strWww ).( empty($strCoord) ? '' : ' '.$strCoord ); break;
  case 'location': $str = '<span class="small">'.$row['location'].'</span>'; break;
  case 'firstdate': $str = QTdatestr($row['firstdate'],'$','',true,false,true); break;
  case 'modifdate': $str = '<span class="small">'.( !empty($oTopic->modifdate) ? QTdatestr($oTopic->modifdate,'$','',true,false,true) : $L['None']).'</span>'; break;
  case 'wisheddate': $str = '<span class="small">'.( !empty($oTopic->wisheddate) ? QTdatestr($oTopic->wisheddate,'$','',true,false,true) : $L['None']).'</span>'; break;
  case 'notifiedname': $str = '<span class="small">'.( $oTopic->notifiedid>0 ? '<a href="qti_usr.php?id='.$oTopic->notifiedid.'" title="'.$L['Userrole_UN'].'" class="small">'.$oTopic->notifiedname.'</a>' : $L['None']).'</span>'; break;
  case 'actorname': $str = '<span class="small">'.( $oTopic->actorid>0 ? '<a href="qti_usr.php?id='.$oTopic->actorid.'" title="'.$L['Userrole_MA'].'" class="small">'.$oTopic->actorname.'</a>' : $L['None']).'</span>'; break;
  case 'coord': $str = $strLatLon; break;
  default:
    $str = '<span class="small">';
    if ( $bTopic )
    {
      if ( isset($oTopic->$strKey) ) $str .= ($oTopic->$strKey==='' ? S : $oTopic->$strKey);
    }
    elseif ( isset($row[$strKey]) )
    {
      $str .= ($row[$strKey]==='' ? S : $row[$strKey]);
    }
    else
    {
      $str .= S;
    }
    $str .= '</span>';
    break;
  }

  echo '<td',$strClass,$strStyle,'>',($str==='' ? S : $str),'</td>'.N;

  // ::::::::::
  }
  // ::::::::::

  echo '</tr>',N;
  break;

case 'print':

  echo '<tr class="data_t ',$strAlt,'">',N;

  // ::::::::::
  foreach($arrFLD as $strKey=>$oFLD) {
  // ::::::::::

  $str = '&nbsp;';
  $arrOptions = ReadValues($oFLD->desc);
  $strClass = ''; if ( isset($arrOptions['class']) ) $strClass = ' class="'.$arrOptions['class'].' td_t_'.$strAlt.'"';
  $strStyle = ''; if ( isset($arrOptions['style']) ) $strStyle = ' style="'.$arrOptions['style'].'"';
  if ( !empty($strStyle) ) {
  if ( strstr($strStyle,'%bg') ) {
  if ( $strKey=='status' || $strKey=='numid' ) {
  $strStyle = str_replace('%bg',$oSYS->statuses[$oTopic->status]['color'],$strStyle);
  }}}

  switch ($strKey)
  {
  case 'icon': $str = AsImg($strTicon,'T',$strTname,'ico i_topic'); break;
  case 'numid': $str = ( $strSectionNumfield=='N' ? '&nbsp;' : '<span class="span_ref">'.sprintf($strSectionNumfield,$oTopic->numid).'</span>' ); break;
  case 'smile': $str = ( $oTopic->smile=='00' ? '&nbsp;' : AsImg($_SESSION[QT]['skin_dir'].'/ico_prefix_'.$strSectionPrefix.'_'.$oTopic->smile.'.gif','[o]',$L['Ico_prefix'][$strSectionPrefix.'_'.$oTopic->smile],'ico ico_prefix') ); break;
  case 'title': $str = ( $oTopic->type=='A' ? '<span class="small">'.$L['News_stamp'].'</span>' : '' ).$oTopic->title.( empty($strCoord) ? '' : ' '.$strCoord ); break;
  case 'you': $str = $oTopic->youreply; break;
  case 'replies': $str = $oTopic->replies; break;
  case 'sectiontitle': $str = ObjTrans('sec','s'.$oTopic->section,$strSectiontitle); break;
  case 'firstpostname': $str = $oTopic->firstpostname.'<br/>'.QTdatestr($oTopic->firstpostdate,'$',''); break;
  case 'lastpostdate': $str = QTdatestr($oTopic->lastpostdate,'$','').'<br/>'.strtolower($L['By']).' '.$oTopic->lastpostname; break;
  case 'status': $str = '<span class="small">'.$oSYS->statuses[$oTopic->status]['statusname'].(empty($oTopic->statusdate) ? '' : '<br/>('.QTdatestr($oTopic->statusdate,'d M','$').')').'</span>'; break;
  case 'tags': $str = '<span class="tag small">'.$strTags.'</span>'; break;
  case 'photo': $str = ( empty($row['photo']) ? S : AsImg(QTI_DIR_PIC.$row['photo'],'',$row['name'],'imagelist') ); break;
  case 'name': $str = '<a href="qti_usr.php?id='.$row['id'].'">'.$row['name'].'</a>'; break;
  case 'role': $str = '<span class="small">'.$L['Userrole'][$row['role']].'</span>'; break;
  case 'contact': $str = ( empty($strMail) ? '<img class="ico" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_e_0.gif" alt="mail" title="no e-mail"/>' : $strMail ).' '.( empty($strWww) ? '<img class="ico" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_w_0.gif" alt="email" title="no web site"/>' : $strWww ).( empty($strCoord) ? '' : ' '.$strCoord ); break;
  case 'location': $str = '<span class="small">'.$row['location'].'</span>'; break;
  case 'firstdate': $str = QTdatestr($row['firstdate'],'$',''); break;
  case 'modifdate': $str = '<span class="small">'.( !empty($oTopic->modifdate) ? QTdatestr($oTopic->modifdate,'$','') : $L['None']).'</span>'; break;
  case 'wisheddate': $str = '<span class="small">'.( !empty($oTopic->wisheddate) ? QTdatestr($oTopic->wisheddate,'$','',true,false,true) : $L['None']).'</span>'; break;
  case 'notifiedname': $str = '<span class="small">'.( $oTopic->notifiedid>0 ? $oTopic->notifiedname : $L['None'] ).'</span>'; break;
  case 'actorname': $str = '<span class="small">'.( $oTopic->actorid>0 ? $oTopic->actorname : $L['None'] ).'</span>'; break;
  case 'coord': $str = '<span class="small">'.(empty($strLatLon) ? S : $strLatLon).'</span>'; break;
  default:
    $str = '<span class="small">';
    if ( $bTopic )
    {
      if ( isset($oTopic->$strKey) ) $str .= ($oTopic->$strKey==='' ? S : $oTopic->$strKey);
    }
    elseif ( isset($row[$strKey]) )
    {
      $str .= ($row[$strKey]==='' ? S : $row[$strKey]);
    }
    else
    {
      $str .= S;
    }
    $str .= '</span>';
    break;
  }

  echo '<td',$strClass,$strStyle,'>',($str==='' ? S : $str),'</td>'.N;

  // ::::::::::
  }
  // ::::::::::

  echo '</tr>',N;
  break;


case 'csv':

  global $strCSV; // this is only for topics !!
  foreach($arrFLD as $strKey=>$oFLD) {
  switch($strKey) {
  case 'csvdate': $strCSV .= ToCsv(substr($oTopic->firstpostdate,0,8)); break;
  case 'csvtime': $strCSV .= (strlen($oTopic->firstpostdate)>9 ? ToCsv(substr($oTopic->firstpostdate,9,2).':'.substr($oTopic->firstpostdate,11,2).':'.substr($oTopic->firstpostdate,13,2)) : '""'); break;
  case 'numid':   $strCSV .= ToCsv(sprintf($strSectionNumfield,$oTopic->numid)); break;
  case 'status':  $strCSV .= ToCsv($oSYS->statuses[$oTopic->status]['statusname']); break;
  case 'smile':   $strCSV .= ToCsv(($oTopic->smile=='00' ? '' : $L['Ico_prefix'][$strSectionPrefix.'_'.$oTopic->smile])); break;
  case 'title':   $strCSV .= ToCsv(($oTopic->type=='A' ? $L['News_stamp'] : '').$oTopic->title); break;
  case 'text':    $strCSV .= ToCsv((!empty($oTopic->preview) ? $oTopic->preview : '')); break;
  case 'sectiontitle': $strCSV .= ToCsv(ObjTrans('sec','s'.$oTopic->section,$strSectiontitle)); break;
  case 'firstpostname': $strCSV .= ToCsv($oTopic->firstpostname.', '.QTdatestr($oTopic->firstpostdate)); break;
  case 'lastpostdate': $strCSV .= ToCsv(QTdatestr($oTopic->lastpostdate).' '.strtolower($L['By']).' '.$oTopic->lastpostname); break;
  case 'wisheddate': $strCSV .= ( !empty($oTopic->wisheddate) ? ToCsv(QTdatestr($oTopic->wisheddate,'$','')) : ToCsv($L['None']) ); break;
  case 'status': $strCSV .= ToCsv($oSYS->statuses[$oTopic->status]);  break;
  case 'replies': $strCSV .= $oTopic->replies.';';  break;
  case 'views': $strCSV .= $oTopic->views.';';  break;
  case 'tags': $strCSV .= ToCsv(strip_tags($strTags)); break;
  case 'id': $strCSV .= $oTopic->id.';'; break;
  case 'actorname': $strCSV .= ToCsv($oTopic->actorname); break;
  case 'notifiedname': $strCSV .= ToCsv($oTopic->notifiedname); break;
  case 'uid': $strCSV .= $oTopic->id.';'; break;
  case 'modifdate': $strCSV .= ( empty($oTopic->modifdate) ? ToCsv($L['None']) : ToCsv(QTdatestr($oTopic->modifdate,'$','')) ); break;
  case 'coord': $strCSV .= ToCsv( str_replace('&#176;','',$strLatLon) ); break;
  }}
  // add return at the end (instead of ;)
  if ( substr($strCSV,-1,1)==';' ) $strCSV = substr($strCSV,0,-1);
  $strCSV .= "\r\n";
  break;

}

}

?>