<?php

// QuickTicket 2.2 build:20090816

if ( !defined('QTI_HTML_DTD') ) define ('QTI_HTML_DTD', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">');
if ( !defined('QTI_HTML_CHAR') ) define ('QTI_HTML_CHAR', 'iso-8859-1');
if ( !defined('QTI_HTML_DIR') ) define ('QTI_HTML_DIR', 'ltr');
if ( !defined('QTI_HTML_LANG') ) define ('QTI_HTML_LANG', 'nl');

// Is is recommended to always use capital on first letter in the translation, script changes to lower case if necessary.
// The character doublequote ["] is FORBIDDEN (reserved for html tags)
// To make a single quote use slashe [\']

// -------------
// TOP LEVEL VOCABULARY
// -------------

// Use the top level vocabulary to give the most appropriate name
// for the topics (object items) managed by this application.
// e.g. Ticket, Incident, Subject, Thread, Request, Faq,...

$L['Topic']='Ticket';
$L['Topics']='Tickets';
$L['topic']=strtolower($L['Topic']);
$L['topics']=strtolower($L['Topics']);

// The top level words are re-used in a lot of translations defined here after

$L['Y']='Ja';
$L['N']='Nee';
$L['Ok']='Ok';

// Specific vocabulary

$L['Domain']='Domein';
  $L['Domains']='Domeinen';
$L['Section']='Sectie';
  $L['Sections']='Secties';
$L['Topic_add']='Nieuwe ticket';
  $L['Topic_del']='Ticket verwijderen';
  $L['Topic_upd']='Ticket bewerken';
$L['User']='Gebruiker';
  $L['Users']='Gebruikers';
  $L['User_del']='Gebruiker verwijderen';
  $L['User_upd']='Profiel bewerken';
$L['Status']='Statuut';
  $L['Statuses']='Statuten';
  $L['Status_add']='Nieuwe statuut';
  $L['Status_del']='Statuut verwijderen';
  $L['Status_upd']='Statuut bewerken';
$L['Member']='Lid';
  $L['Members']='Leden';
$L['Message']='Bericht';
  $L['Messages']='Berichten';
  $L['Message_deleted']='Bericht verwijderd...';
$L['Reply']='Antwoord';
  $L['Replys']='Antwoorden';
$L['Forward']='Verstuurd bericht';
  $L['Forwards']='verstuurd berichten';
$L['News']='Info';
  $L['Newss']='Infos'; // In other languages: News=One news, Newss=Several news
  $L['News_stamp']='Nieuws: ';
$L['Attachment']='Attachment';
$L['Notify_also']='Op de hoogte brengen';
$L['Drop_attachment']='Attachment wegnemen';
$L['Wisheddate']='Oplevering';
$L['H_Wisheddate']='(jjjj-mm-dd) Gewenste leveringsdatum';
$L['Ref']='Ref.';
$L['Title']='Titel';
$L['Smiley']='Voorvoegsel';
$L['Notification']='Nota';
$L['Username']='Gebruikersnaam';
  $L['Userrole']['A']='Administrateur'; $L['Userroles']['A']='Administrateurs';
  $L['Userrole']['M']='Staff';          $L['Userroles']['M']='Staffs';
  $L['Userrole']['U']='Gebruiker';      $L['Userroles']['U']='Gebruikers';
  $L['Userrole']['V']='Bezoeker';       $L['Userroles']['V']='Bezoekers';
  $L['Userrole_MF']='Sectie moderator';
  $L['Userrole_MA']='Acteur';
  $L['Userrole_UN']='Gebruiker op de hoogte';
$L['Joined']='Geregistreerd op';
$L['Avatar']='Foto';
$L['Signature']='Onderschrift';
$L['Role']='Rang';
$L['Topic_starter']='Auteur';
$L['Modified_by']='Bewerkt door';
$L['Deleted_by']='Geschrapt door';
$L['Top_participants']='Top deelnemers';
$L['Password']='Wachtwoord';

// Common

$L['Add']='Toevoegen';
$L['Advanced_reply']='Voorproef...';
$L['All']='Alles';
$L['Birthday']='Geboortedatum';
$L['Birthdays_calendar']='Verjaardag kalender';
$L['By']='Door';
$L['Change']='Bewerk';
$L['Change_status']='Statuut veranderen...';
$L['Change_type']='Type veranderen...';
$L['Changed']='Bewerkt';
$L['Close']='Afsluiten';
$L['Closed']='Gesloten';
$L['Containing']='Bevat';
$L['Contact']='Contact';
$L['Continue']='Voortduren';
$L['Coord']='Co&ouml;rdinaten';
$L['Coord_latlon']='(lat,lon)';
$L['Date']='Datum';
$L['Dates']='Datum';
$L['Day']='Dag';
$L['Days']='Dagen';
$L['Delete_tags']='Verwijderen (click een woord of type * om alles te verwijderen)';
$L['Destination']='Bestemming';
$L['Details']='Details';
$L['Display_at']='Tonen op datum van';
$L['Email']='E-mail'; $L['No_Email']='Geen e-mail';
$L['Exit']='Uitrit';
$L['First']='Eerste';
$L['Goodbye']='U bent uitgelogd... Tot ziens';
$L['Goto']='Ga naar';
$L['H_Website']='Uw website url (met http://)';
$L['Help']='Hulp';
$L['Hidden']='Verborgen';
$L['I_wrote']='Ik schreef';
$L['Information']='Informatie';
$L['Items_per_month']='Tickets per maand';
$L['Items_per_month_cumul']='Cumul tickets per maand';
$L['Last']='Laatste';
$L['Legend']='Legend';
$L['Location']='Woonplaats';
$L['Maximum']='Maximum';
$L['Minimum']='Minimum';
$L['Modified']='Verandered';
$L['Month']='Maand';
$L['Next']='Volgende';
$L['None']='Niets';
$L['Options']='Opties';
$L['or']='of'; // lowercase
$L['Page']='pagina';
$L['Pages']='pagina\'s';
$L['Phone']='Telefoon';
$L['Preview']='Voorproef';
$L['Previous']='Vorige';
$L['Privacy']='Priv&eacute;-leven';
$L['Reason']='Reden';
$L['Remove']='Uitwissen';
$L['Result']='Resultaat';
$L['Results']='Resultaten';
$L['Save']='Saven';
$L['Seconds']='Seconden';
$L['Selected_from']='geselecteerd uit';
$L['Send']='Zenden';
$L['Send_on_behalf']='Zenden namens';
$L['Statistics']='Statistieken';
$L['Tag']='Categorie';
$L['Tags']='Categorie&euml;n';
$L['Time']='Uren';
$L['Total']='Totaal';
$L['Type']='Type';
$L['Views']='Bekeken';
$L['Website']='Website'; $L['No_Website']='Geen website';
$L['Welcome']='Welkom';
$L['Welcome_to']='Welkom voor een nieuwe gebruiker, ';
$L['Welcome_not']='Ik ben %s niet !';
$L['Year']='Jaar';

// Menu

$L['FAQ']='FAQ';
$L['Search']='Zoeken';
$L['Memberlist']='Gebruikerslijst';
$L['Login']='Inloggen';
$L['Logout']='Uitloggen';
$L['Register']='Registreer';
$L['Profile']='Profiel';
$L['Administration']='Administratie';
$L['Legal']='Privacybeleid';
$L['Coppa_form']='Coppa&nbsp;vorm';

// Section // use &nbsp; to avoid double ligne buttons

$L['Post_new_topic']='Nieuwe&nbsp;ticket';
$L['Post_reply']='Antwoord';
$L['Topic_closed']='Gesloten&nbsp;ticket';
$L['First_message']='Eerste&nbsp;bericht';
$L['Last_message']='Laatste&nbsp;bericht';
$L['Goto_message']='[<b>&raquo;</b>]';
$L['H_Goto_message']='Laatste&nbsp;bericht';

$L['My_last_topic']='Mijn&nbsp;laatste&nbsp;ticket';
$L['All_my_topics']='Mijn&nbsp;tickets';
$L['All_my_assigned']='Mijn&nbsp;taken';
$L['Topic_handled']='Ticket behandeld';
$L['Topics_handled']='Tickets behandeld';
$L['Topic_forwarded']='Ticket is naar %s gestruurd.';

$L['You_reply']='Ik antwoord';
$L['Quote']='Quote';
$L['Edit']='Bewerken';
$L['Delete']='Uitwissen';
$L['Move']='Verplaatsen';
$L['Move_to']='Verplatsen';
$L['Change_actor']='Werknemer';
$L['Close_my_topic']='Ik sluit mijn ticket';

$L['Quick_reply']='Snel antwoord';
$L['Previous_replies']='Vorige berichten';
$L['Close_topic']='Sluit dit ticket';
$L['Edit_message']='Bewerk bericht';
$L['Delete_message']='Verwijder bericht';

$L['Move_keep']='Houd origineel nummer';
$L['Move_reset']='Verwijzingen naar 0';
$L['Move_follow']='Volgt sectienummer';
$L['Edit_start']='Wijziging beginnen';
$L['Edit_stop']='Wijziging stoppen';

$L['Topic_closed_show']='Gesloten aanvragen: tonen';
$L['Topic_closed_hide']='Gesloten aanvragen: verborgen';
$L['Topic_news_show']='Nieuws: tonen';
$L['Topic_news_hide']='Nieuws: verborgen';
$L['Topic_show_all']='Alle secties verzamelen';
$L['Topic_show_this']='Alleen dit sectie tonen';
$L['Last_column']='Extra colonne';

// Stats

$L['General_site']='Algemene site';
$L['Board_start_date']='Applicatie begin datum';

// Search

$L['Recent_messages']='Recente&nbsp;'.$L['topics'];
$L['All_news']='Alle&nbsp;mededelingen';
$L['All_my_topics']='Alle&nbsp;mijn&nbsp;'.$L['topics'];

$L['Advanced_search']='Geavanceerd onderzoek';
$L['H_Advanced']='(een tiketnummer of een woord)';
$L['Keywords']='Sleutelwoord(en)';
$L['Search_option']='Onderzoeksoptie';
$L['Search_criteria']='Onderzoekscriterium';
$L['Search_by_key']='Zoeken met sleutelwoord(en)';
$L['Search_by_ref']='Zoeken met nummer';
$L['Search_by_status']='Zoeken met statuut';
$L['Search_result']='Resultaat van het onderzoek';
$L['In_title_only']='In titel alleen';
$L['In_all_sections']='In alle secties';
$L['Any_time']='Alle tijd';
$L['Any_status']='Alle statuut';
$L['At_least_0']='Met of zonder antwoord';
$L['At_least_1']='Minstens een antwoord';
$L['At_least_2']='Minstens 2 antwoorden';
$L['At_least_3']='Minstens 2 antwoorden';
$L['H_Reference']='(typ het numerieke deel)';
$L['Too_many_keys']='Te veel sleutelwoorden';
$L['Search_by_words']='Elk woord afzonderlijk zoeken';
$L['Search_exact_words']='Worden samen zoeken';
$L['Search_by_date']='Zoeken met datum';
$L['This_week']='Deze week';
$L['This_month']='Deze maand';
$L['This_year']='Dit jaar';
$L['With_tag']= 'Met categorie';
$L['Show_only_tag']='Tonen alleen deze met categorie';
$L['Tag_only']='alleen met categorie'; // must be in lowercase
$L['H_Tag_input']='Met de kommapunt, kunt u verschillende categorie&euml;n invoeren (b.v.: c1;c2 betekend tickets met categorie "c1" of "c2").';

// Restrictions

$L['R_member']='De toegang is beperkt tot slechts leden.<br/><br/>Gelieve in te loggen, of ga naar Registreerd om lid te worden.<br/><br/><a href="qti_index.php">Exit</a>';
$L['R_staff']='De toegang is beperkt tot slechts staff. <a href="qti_index.php">Exit</a>';
$L['R_security']='De veiligheid instellingen laten deze functie geen toe.';

// Errors

$L['E_access']='De toegang is beperkt...';
$L['E_already_used']='Reeds gebruikt';
$L['E_char_max']='(maximum %d tekens)';
$L['E_editing']='Data zijn verandered. Verlaten zonder saven?';
$L['E_file_size']='Het bestand is te groot';
$L['E_invalid']='ongeldig';
$L['E_javamail']='Veiligheid: java is nodig om e-mail te zien';
$L['E_line_max']='(maximum %d lijnen)';
$L['E_mandatory']='Verplicht data niet gevonden';
$L['E_missing_http']='url moet met http:// of https:// beginnen';
$L['E_no_desc']='Geen beschrijving';
$L['E_no_public_section']='Dit systeem bevat geen openbaar sectie. De priv&eacute;sectie toegang vereist login.';
$L['E_no_result']='Geen r&eacute;sultaat';
$L['E_no_title']='Een titel is verplicht';
$L['E_no_visible_section']='Dit systeem bevat geen sectie zichtbaar voor u.';
$L['E_ref_search']='Decimaal (of komma) niet geldig. Het gebruik aanhalingsteken als u een aantal als sleutelwoord wilt zoeken.';
$L['E_section_closed']='Sectie&nbsp;is&nbsp;gesloten'; // use &nbsp; as space to avoid double ligne buttons
$L['E_text']='Probleem met uw bericht.';
$L['E_too_long']='Te lang bericht';
$L['E_too_much']='Te veel berichten vandaag...<br/><br/>Om veiligheidsredenen, is de aantallen toegestane posten beperkt. Probeer opnieuw morgen. Bedankt...';
$L['E_topic_private']='(of priv&eacute; aanvragen)';
$L['E_wait']='Gelieve te wachten een paar seconden';

// Success

$L['S_update']='Voltooide update...';
$L['S_delete']='Schrap voltooid...';
$L['S_insert']='Succesvolle verwezenlijking...';
$L['S_save']='Sparen voltooid...';
$L['S_message_saved']='Het bericht wordt bewaard...<br/>Dank u';

// Dates

$L['dateMMM']=array(1=>'Januari','Februari','Maart','April','Mei','Juni','Juli','Augustus','Septembre','Oktober','November','December');
$L['dateMM'] =array(1=>'Jan','Feb','Mrt','Apr','Mei','Jun','Jul','Aug','Sep','Okt','Nov','Dec');
$L['dateM']  =array(1=>'J','F','M','A','M','J','J','A','S','O','N','D');
$L['dateDDD']=array(1=>'Maandag','Dinsdag','Woensdag','Donderdag','Vrijdag','Zaterdag','Zondag');
$L['dateDD'] =array(1=>'Ma','Di','Wo','Do','Vr','Za','Zo');
$L['dateD']  =array(1=>'M','D','W','D','V','Z','Z');
$L['dateSQL']=array(
  'January'  => 'januari',
  'February' => 'februari',
  'March'    => 'maart',
  'April'    => 'april',
  'May'      => 'mei',
  'June'     => 'juni',
  'July'     => 'juli',
  'August'   => 'augustus',
  'September'=> 'september',
  'October'  => 'oktober',
  'November' => 'november',
  'December' => 'december',
  'Monday'   => 'maandag',
  'Tuesday'  => 'dinsdag',
  'Wednesday'=> 'woensdag',
  'Thursday' => 'donderdag',
  'Friday'   => 'vrijdag',
  'Saturday' => 'zaterdag',
  'Sunday'   => 'zondag',
  'Today'=>'Vandaag',
  'Yesterday'=>'Gisteren',
  'Jan'=>'jan',
  'Feb'=>'feb',
  'Mar'=>'mrt',
  'Apr'=>'apr',
  'May'=>'mei',
  'Jun'=>'jun',
  'Jul'=>'jul',
  'Aug'=>'aug',
  'Sep'=>'sep',
  'Oct'=>'okt',
  'Nov'=>'nov',
  'Dec'=>'dec',
  'Mon'=>'ma',
  'Tue'=>'di',
  'Wed'=>'wo',
  'Thu'=>'do',
  'Fri'=>'vr',
  'Sat'=>'za',
  'Sun'=>'zo');
?>