<?php

// QuickTicket 2.2.2 build:20090816

include('qti_stats_inc.php');

// DISPLAY title & option

echo '<table class="hidden" cellspacing="0">';
echo '<tr class="hidden" style="vertical-align:middle;">';
echo '<td><h2>',$intYear-1,' - ',$intYear,($s>=0 ? ' ('.$oSYS->sections[$s].')' : ''),(empty($tag) ? '' : ', '.$L['With_tag'].' '.str_replace(';',' '.$L['or'].' ',$tag)),'</h2></td>',N;
if ( $oSYS->output=='screen' ) echo '<td class="small" style="text-align:right">',implode(' &middot; ',$arrMenuTime),'</td>';
echo '</tr></table>
';

// -----
// DISPLAY VALUES
// -----

// -----
foreach($arrYears as $intYear) {
// -----

// Display table header

echo '<table class="data_t" cellspacing="0">
<tr class="data_t">
<td class="th_o" style="width:85px">',$intYear,'</td>
<td class="th_o" style="width:14px">&nbsp;</td>
';
switch($ch['time'])
{
case 'q': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="th_o" style="text-align:center;">Q',$i,'</td>'; } break;
case 'm': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="th_o" style="text-align:center;">',$L['dateMM'][$i],'</td>'; } break;
case 'd': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="th_o" style="text-align:center;">',str_replace(' ','<br/>',QTdatestr(DateAdd($strTendaysago,$i,'day'),'d M','')),'</td>'; } break;
}
echo '<td class="th_o" style="text-align:center;"><b>',($ch['time']=='d' ? '10 '.strtolower($L['Days']) : $L['Year']),'</b></td>
</tr>';

// DISPLAY TOPICS [value]

echo '<tr class="data_o">',N;
echo '<td class="th_o">',$L['Topics'],'</td>',N;
echo '<td class="th_o"><div style="margin:0 auto;background-color:'.($intYear==$intCurrentYear ? '#000066' : '#00AFFF').';width:8px;height:10px">&nbsp;</div></td>',N;
for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
{
  echo '<td class="td_o" style="text-align:center;">',(isset($arrT[$intYear][$intBt]) ? $arrT[$intYear][$intBt] : '&middot;'),'</td>',N;
}
echo '<td class="td_o" style="text-align:center;padding:5px;"><b>',$arrTs[$intYear],'</b></td></tr>',N;

// DISPLAY MESSAGES [value]

echo '<tr class="data_o">',N;
echo '<td class="th_o">',$L['Replys'],'</td>',N;
echo '<td class="th_o"><div style="margin:0 auto;background-color:'.($intYear==$intCurrentYear ? '#990099' : '#F1B8FF').';width:8px;height:10px">&nbsp;</div></td>',N;
for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
{
  echo '<td class="td_o" style="text-align:center;">',(isset($arrM[$intYear][$intBt]) ? $arrM[$intYear][$intBt] : '&middot;'),'</td>',N;
}
echo '<td class="td_o" style="text-align:center;padding:5px;"><b>',$arrMs[$intYear],'</b></td></tr>',N;

// DISPLAY USERS [value]

echo '<tr class="data_o">',N;
echo '<td class="th_o">',$L['Users'],'*</td>',N;
echo '<td class="th_o"><div style="margin:0 auto;background-color:'.($intYear==$intCurrentYear ? '#009999' : '#00E7B7').';width:8px;height:10px">&nbsp;</div></td>',N;
for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
{
  echo '<td class="td_o" style="text-align:center;">',(isset($arrU[$intYear][$intBt]) ? $arrU[$intYear][$intBt] : '&middot;'),'</td>',N;
}
echo '<td class="td_o" style="text-align:center;padding:5px;"><b>',$arrUs[$intYear],'</b></td></tr>',N;
echo '</table>
';

// -----
}
// -----

// -----
// DISPLAY TRENDS [value|percent]
// -----

// Table header

if ( $oSYS->output=='screen' ) echo '<p class="small" style="text-align:right">',implode(' &middot; ',$arrMenuTrend),'</p>';

echo '<table class="data_t" cellspacing="0">
<tr class="data_t">
<td class="th_o" style="width:85px">',$L['Trends'],'</td>
<td class="th_o" style="width:14px">&nbsp;</td>
';
switch($ch['time'])
{
case 'q': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="th_o" style="text-align:center;">Q',$i,'</td>'; } break;
case 'm': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="th_o" style="text-align:center;">',$L['dateMM'][$i],'</td>'; } break;
case 'd': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="th_o" style="text-align:center;">',str_replace(' ','<br/>',QTdatestr(DateAdd($strTendaysago,$i,'day'),'d M','')),'</td>'; } break;
}
echo '<td class="th_o" style="text-align:center;"><b>',($ch['time']=='d' ? '10 '.strtolower($L['Days']) : $L['Year']),'</b></td>
</tr>';

// Topics trends

echo '<tr class="data_o">',N;
echo '<td class="th_o">',$L['Topics'],'</td>',N;
echo '<td class="th_o">&nbsp;</td>',N;

for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
{
  $str = '0';
  $i = QTtrend((isset($arrT[$intYear][$intBt]) ? $arrT[$intYear][$intBt] : 0),(isset($arrT[$intYear-1][$intBt]) ? $arrT[$intYear-1][$intBt] : 0),$ch['trend']=='p');
  if ( isset($i) )
  {
    if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
    if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  }
  else
  {
    $str = '&middot;';
  }
  echo '<td class="td_o" style="text-align:center;">',$str,'</td>',N;  
}

$str = '0';
$i = QTtrend($arrTs[$intYear],$arrTs[$intYear-1],$ch['trend']=='p');
if ( isset($i) )
{
  if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
}
else
{
  $str = '&middot;';
}
echo '<td class="td_o" style="text-align:center;"><b>',$str,'</b></td></tr>',N;

// Replies trends

echo '<tr class="data_o">',N;
echo '<td class="th_o">',$L['Replys'],'</td>',N;
echo '<td class="th_o">&nbsp;</td>',N;

for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
{
  $str = '0';
  $i = QTtrend((isset($arrM[$intYear][$intBt]) ? $arrM[$intYear][$intBt] : 0),(isset($arrM[$intYear-1][$intBt]) ? $arrM[$intYear-1][$intBt] : 0),$ch['trend']=='p');
  if ( isset($i) )
  {
    if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
    if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  }
  else
  {
    $str = '&middot;';
  }
  echo '<td class="td_o" style="text-align:center;">',$str,'</td>',N;  
}

$str = '0';
$i = QTtrend($arrMs[$intYear],$arrMs[$intYear-1],$ch['trend']=='p');
if ( isset($i) )
{
  if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
}
else
{
  $str = '&middot;';
}
echo '<td class="td_o" style="text-align:center;"><b>',$str,'</b></td></tr>',N;

// Users trends

echo '<tr class="data_o">',N;
echo '<td class="th_o">',$L['Users'],'*</td>',N;
echo '<td class="th_o">&nbsp;</td>',N;

for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
{
  $str = '0';
  $i = QTtrend((isset($arrU[$intYear][$intBt]) ? $arrU[$intYear][$intBt] : 0),(isset($arrU[$intYear-1][$intBt]) ? $arrU[$intYear-1][$intBt] : 0),$ch['trend']=='p');
  if ( isset($i) )
  {
    if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
    if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  }
  else
  {
    $str = '&middot;';
  }
  echo '<td class="td_o" style="text-align:center;">',$str,'</td>',N;  
}

$str = '0';
$i = QTtrend($arrUs[$intYear],$arrUs[$intYear-1],$ch['trend']=='p');
if ( isset($i) )
{
  if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
}
else
{
  $str = '&middot;';
}
echo '<td class="td_o" style="text-align:center;"><b>',$str,'</b></td></tr>',N;

echo '</table>
';

echo '<p>*  <span class="small">',$L['Distinct_users'],'</span></p>
';

// After values display change the null values to zero to be able to make charts

foreach($arrYears as $intYear)
{
$arrT[$intYear] = QTarrayzero($arrT[$intYear]);
$arrM[$intYear] = QTarrayzero($arrM[$intYear]);
$arrU[$intYear] = QTarrayzero($arrU[$intYear]);
}

// -----
// GRAPH
// -----

if ( file_exists('pChart/pChart.class') && file_exists('pChart/pData.class') && file_exists('pChart/pCache.class') && !isset($_GET['oldgraph']) )
{
  // abscise Label
  $arrA = array();
  switch($ch['time'])
  {
  case 'q': for ($i=1;$i<=$intMaxBt;$i++) { $arrA[$i]='Q'.$i; } break;
  case 'm': for ($i=1;$i<=$intMaxBt;$i++) { $arrA[$i]=$L['dateMM'][$i]; } break;
  case 'd': for ($i=1;$i<=$intMaxBt;$i++) { $arrA[$i]=substr(DateAdd($strTendaysago,$i,'day'),-2,2); } break;
  }

  // Standard inclusions and prepare CACHE
  include('pChart/pData.class');
  include('pChart/pChart.class');
  include('pChart/pCache.class');
  $Cache = new pCache('pChart/Cache/');

  // Check cache
  $intHandle = opendir('pChart/Cache');
  $i = 0;
  while ( false!==($strFile = readdir($intHandle)) ) $i++;
  closedir($intHandle);
  // clear cache if to much files
  if ( $i>60 || isset($_GET['clearcache']) ) $Cache->ClearCache();
  
  // -------
  // Graph 1  [value]
  // -------

  // Dataset definition
  $strName = $tt.'1'.$intYear.implode('',$ch);
  $DataSet = new pData;
  $DataSet->AddPoint($arrT[$intYear-1],'Serie1');
  $DataSet->AddPoint($arrT[$intYear],'Serie2');
  $DataSet->AddPoint($arrA,'Serie3');
  $DataSet->AddSerie('Serie1');
  $DataSet->AddSerie('Serie2');
  $DataSet->SetSerieName($intYear-1,'Serie1');
  $DataSet->SetSerieName($intYear,'Serie2');
  $DataSet->SetAbsciseLabelSerie('Serie3');
  $intTopY = QTroof( array(max($arrT[$intYear-1]),max($arrT[$intYear])) );

  if ( !$Cache->IsInCache($strName,$DataSet->GetData()) )
  {    
    // Initialise the graph 
    $oChart = new pChart(600,230);
    $oChart->setColorPalette(0,0,175,255); //color color1b
    $oChart->setColorPalette(1,0,0,102); //color 1
    $oChart->setFontProperties('pChart/Fonts/tahoma.ttf',8);
    $oChart->setGraphArea(40,35,560,195);
    $oChart->setFixedScale(0,$intTopY);
    $oChart->drawFilledRoundedRectangle(7,7,593,223,5,240,240,240);
    $oChart->drawGraphArea(255,255,255,TRUE);
    $oChart->drawScale($DataSet->GetData(),$DataSet->GetDataDescription(),SCALE_START0,125,125,125,TRUE,0,0,TRUE);
    $oChart->drawGrid(4,TRUE,230,230,230,50);

    // Draw the line/bar graph
    if ( strtolower($ch['type'])=='l' )
    {
    $oChart->drawFilledLineGraph($DataSet->GetData(),$DataSet->GetDataDescription(),40,TRUE);
    $oChart->drawPlotGraph($DataSet->GetData(),$DataSet->GetDataDescription(),3,2,255,255,255);
    }
    else
    {
    $oChart->drawBarGraph($DataSet->GetData(),$DataSet->GetDataDescription(),TRUE);
    }

    // label with the trend
    if ( $ch['type']=='B' || $ch['type']=='L' )
    {
      $oChart->setFontProperties('pChart/Fonts/tahoma.ttf',7);
      for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
      {
      $i = QTtrend((isset($arrT[$intYear][$intBt]) ? $arrT[$intYear][$intBt] : 0),(isset($arrT[$intYear-1][$intBt]) ? $arrT[$intYear-1][$intBt] : 0),$ch['trend']=='p');
      if ( $i>0 ) $oChart->setLabel($DataSet->GetData(),$DataSet->GetDataDescription(),'Serie2',$arrA[$intBt],'+'.$i.($ch['trend']=='p' ? '%' : ''),220,220,220);
      if ( $i<0 ) $oChart->setLabel($DataSet->GetData(),$DataSet->GetDataDescription(),'Serie2',$arrA[$intBt],$i.($ch['trend']=='p' ? '%' : ''),220,220,220);
      }
    }
    
    // Finish the graph
    $oChart->setFontProperties("pChart/Fonts/tahoma.ttf",10);
    $oChart->drawTitle(40,25,$L['Topics_per_'.$ch['time']].($ch['value']=='p' ? ' (%)' : ''),50,50,50,560);
    $oChart->setFontProperties("pChart/Fonts/tahoma.ttf",9);
    $oChart->drawLegend(520,18,$DataSet->GetDataDescription(),255,255,255);
    $Cache->WriteToCache($strName,$DataSet->GetData(),$oChart);
    $oChart->Render('pChart/tmp/'.$strName.'.png');
  }
  
  // -------
  // Graph 2
  // -------

  // Dataset definition
  $strName = $tt.'2'.$intYear.implode('',$ch);
  $DataSet = new pData;
  $DataSet->AddPoint($arrM[$intYear-1],'Serie1');
  $DataSet->AddPoint($arrM[$intYear],'Serie2');
  $DataSet->AddPoint($arrA,'Serie3');
  $DataSet->AddSerie('Serie1');
  $DataSet->AddSerie('Serie2');
  $DataSet->SetSerieName($intYear-1,'Serie1');
  $DataSet->SetSerieName($intYear,'Serie2');
  $DataSet->SetAbsciseLabelSerie('Serie3');
  $intTopY = QTroof( array(max($arrM[$intYear-1]),max($arrM[$intYear])) );
  
  if ( !$Cache->IsInCache($strName,$DataSet->GetData()) )
  {    
    // Initialise the graph 
    $oChart = new pChart(640,230);
    $oChart->setColorPalette(0,241,184,255); //color 2b
    $oChart->setColorPalette(1,153,0,153); //color 2
    $oChart->setFontProperties('pChart/Fonts/tahoma.ttf',8);
    $oChart->setGraphArea(40,35,560,195);
    $oChart->setFixedScale(0,$intTopY);
    $oChart->drawFilledRoundedRectangle(7,7,593,223,5,240,240,240);
    $oChart->drawGraphArea(255,255,255,TRUE);
    $oChart->drawScale($DataSet->GetData(),$DataSet->GetDataDescription(),SCALE_START0,125,125,125,TRUE,0,0,TRUE);
    $oChart->drawGrid(4,TRUE,230,230,230,50);

    // Draw the line/bar graph
    if ( strtolower($ch['type'])=='l' )
    {
    $oChart->drawFilledLineGraph($DataSet->GetData(),$DataSet->GetDataDescription(),40,TRUE);
    $oChart->drawPlotGraph($DataSet->GetData(),$DataSet->GetDataDescription(),3,2,255,255,255);
    }
    else
    {
    $oChart->drawBarGraph($DataSet->GetData(),$DataSet->GetDataDescription(),TRUE);
    }

    // label with the trend
    if ( $ch['type']=='B' || $ch['type']=='L' )
    {
      $oChart->setFontProperties('pChart/Fonts/tahoma.ttf',7);
      for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
      {
      $i = QTtrend((isset($arrM[$intYear][$intBt]) ? $arrM[$intYear][$intBt] : null),(isset($arrM[$intYear-1][$intBt]) ? $arrM[$intYear-1][$intBt] : 0),$ch['trend']=='p');
      if ( $i>0 ) $oChart->setLabel($DataSet->GetData(),$DataSet->GetDataDescription(),'Serie2',$arrA[$intBt],'+'.$i.($ch['trend']=='p' ? '%' : ''),220,220,220);
      if ( $i<0 ) $oChart->setLabel($DataSet->GetData(),$DataSet->GetDataDescription(),'Serie2',$arrA[$intBt],$i.($ch['trend']=='p' ? '%' : ''),220,220,220);
      }
    }    
    // Finish the graph
    $oChart->setFontProperties("pChart/Fonts/tahoma.ttf",10);
    $oChart->drawTitle(40,25,$L['Replies_per_'.$ch['time']].($ch['value']=='p' ? ' (%)' : ''),50,50,50,560);
    $oChart->setFontProperties("pChart/Fonts/tahoma.ttf",9);
    $oChart->drawLegend(520,18,$DataSet->GetDataDescription(),255,255,255);
    $Cache->WriteToCache($strName,$DataSet->GetData(),$oChart);
    $oChart->Render('pChart/tmp/'.$strName.'.png');
  }
  
  // -------
  // Graph 3
  // -------

  // Dataset definition
  $strName = $tt.'3'.$intYear.implode('',$ch);
  $DataSet = new pData;
  $DataSet->AddPoint($arrU[$intYear-1],'Serie1');
  $DataSet->AddPoint($arrU[$intYear],'Serie2');
  $DataSet->AddPoint($arrA,'Serie3');
  $DataSet->AddSerie('Serie1');
  $DataSet->AddSerie('Serie2');
  $DataSet->SetSerieName($intYear-1,'Serie1');
  $DataSet->SetSerieName($intYear,'Serie2');
  $DataSet->SetAbsciseLabelSerie('Serie3');
  $intTopY = QTroof( array(max($arrU[$intYear-1]),max($arrU[$intYear])) );

  if ( !$Cache->IsInCache($strName,$DataSet->GetData()) )
  {    
    // Initialise the graph 
    $oChart = new pChart(640,230);
    $oChart->setColorPalette(0,0,231,183); //color 3b
    $oChart->setColorPalette(1,0,153,153); //color 3
    $oChart->setFontProperties('pChart/Fonts/tahoma.ttf',8);
    $oChart->setGraphArea(40,35,560,195);
    $oChart->setFixedScale(0,$intTopY);
    $oChart->drawFilledRoundedRectangle(7,7,593,223,5,240,240,240);
    $oChart->drawGraphArea(255,255,255,TRUE);
    $oChart->drawScale($DataSet->GetData(),$DataSet->GetDataDescription(),SCALE_START0,125,125,125,TRUE,0,0,TRUE);
    $oChart->drawGrid(4,TRUE,230,230,230,50);

    // Draw the line/bar graph
    if ( strtolower($ch['type'])=='l' )
    {
    $oChart->drawFilledLineGraph($DataSet->GetData(),$DataSet->GetDataDescription(),40,TRUE);
    $oChart->drawPlotGraph($DataSet->GetData(),$DataSet->GetDataDescription(),3,2,255,255,255);
    }
    else
    {
    $oChart->drawBarGraph($DataSet->GetData(),$DataSet->GetDataDescription(),TRUE);
    }

    // label with the trend
    if ( $ch['type']=='B' || $ch['type']=='L' )
    {
      $oChart->setFontProperties('pChart/Fonts/tahoma.ttf',7);
      for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
      {
      $i = QTtrend((isset($arrU[$intYear][$intBt]) ? $arrU[$intYear][$intBt] : null),(isset($arrU[$intYear-1][$intBt]) ? $arrU[$intYear-1][$intBt] : 0),$ch['trend']=='p');
      if ( $i>0 ) $oChart->setLabel($DataSet->GetData(),$DataSet->GetDataDescription(),'Serie2',$arrA[$intBt],'+'.$i.($ch['trend']=='p' ? '%' : ''),220,220,220);
      if ( $i<0 ) $oChart->setLabel($DataSet->GetData(),$DataSet->GetDataDescription(),'Serie2',$arrA[$intBt],$i.($ch['trend']=='p' ? '%' : ''),220,220,220);
      }
    }
    
    // Finish the graph
    $oChart->setFontProperties("pChart/Fonts/tahoma.ttf",10);
    $oChart->drawTitle(40,25,$L['Users_per_'.$ch['time']].($ch['value']=='p' ? ' (%)' : ''),50,50,50,560);
    $oChart->setFontProperties("pChart/Fonts/tahoma.ttf",9);
    $oChart->drawLegend(520,18,$DataSet->GetDataDescription(),255,255,255);
    $Cache->WriteToCache($strName,$DataSet->GetData(),$oChart);
    $oChart->Render('pChart/tmp/'.$strName.'.png');
  }
  
  // -------
  // DISPLAY
  // -------

  echo '<div style="margin:0 auto; width:600px">',N;
  if ( $oSYS->output=='screen' ) echo '<p class="small" style="text-align:right">',implode(' &middot; ',$arrMenuType),'</p>';
  echo '<img src="pChart/tmp/'.$tt.'1'.$intYear.implode('',$ch).'.png"/><br/>';
  echo '<img src="pChart/tmp/'.$tt.'2'.$intYear.implode('',$ch).'.png"/><br/>';
  echo '<img src="pChart/tmp/'.$tt.'3'.$intYear.implode('',$ch).'.png"/><br/>';
  echo '</div>',N;

}
elseif ( file_exists('bin/qt_lib_graph.php') && file_exists($_SESSION[QT]['skin_dir'].'/qti_main2.css') )
{

  if ( $oSYS->output=='screen' ) echo '<p class="small" style="text-align:right">',implode(' &middot; ',$arrMenuValue),'</p>';

  // TOPIC first serie
  
  $intTopY = QTroof( array(max($arrT[$intYear-1]),max($arrT[$intYear])) );
  
  echo '<table class="data_t" cellspacing="0">',N;
  echo '<tr class="data_t">',N;
  echo '<td class="td_o" style="width:355px">',N;
  
  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrT[$intYear-1])),350,100,$intTopY,2,'P',$L['Topics_per_'.$ch['time']].' (%)'.' '.($intYear-1));
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,$arrT[$intYear-1]),320,100,$intTopY,2,true,$L['Topics_per_'.$ch['time']].' '.($intYear-1));
  }

  echo '</td>',N;  
  echo '<td class="td_o">&nbsp;</td>',N;
  echo '<td class="td_o" style="width:355px">',N;

  // TOPIC second serie

  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrT[$intYear])),350,100,$intTopY,2,'P',$L['Topics_per_'.$ch['time']].' (%)'.' '.$intYear);
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,$arrT[$intYear]),320,100,$intTopY,2,true,$L['Topics_per_'.$ch['time']].' '.$intYear);
  }

  echo '</td>',N;
  echo '</tr>',N;

  // MESSAGE first serie
  
  $intTopY = QTroof( array(max($arrM[$intYear-1]),max($arrM[$intYear])) );
  
  echo '<tr class="data_o">',N;
  echo '<td class="td_o" style="width:355px">',N;
  
  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrM[$intYear-1])),350,100,$intTopY,2,'P',$L['Replies_per_'.$ch['time']].' (%)'.' '.($intYear-1),'','2');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,$arrM[$intYear-1]),320,100,$intTopY,2,true,$L['Replies_per_'.$ch['time']].' '.($intYear-1),'','2');
  }

  echo '</td>',N;  
  echo '<td class="td_o">&nbsp;</td>',N;
  echo '<td class="td_o" style="width:355px">',N;

  // MESSAGE second serie

  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrM[$intYear])),350,100,$intTopY,2,'P',$L['Replies_per_'.$ch['time']].' (%)'.' '.$intYear,'','2');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,$arrM[$intYear]),320,100,$intTopY,2,true,$L['Replies_per_'.$ch['time']].' '.$intYear,'','2');
  }

  echo '</td>',N;
  echo '</tr>',N;

  // USER first serie
  
  $intTopY = QTroof( array(max($arrU[$intYear-1]),max($arrU[$intYear])) );
  
  echo '<tr class="data_o">',N;
  echo '<td class="td_o" style="width:355px">',N;
  
  if ( $ch['value']=='a' ) 
  {
  QTbarchart(QTarraymerge($arrA,$arrU[$intYear-1]),320,100,$intTopY,2,true,$L['Users_per_'.$ch['time']].' '.($intYear-1),'','3');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrU[$intYear-1])),350,100,$intTopY,2,'P',$L['Users_per_'.$ch['time']].' (%)'.' '.($intYear-1),'','3');
  }

  echo '</td>',N;  
  echo '<td class="td_o">&nbsp;</td>',N;
  echo '<td class="td_o" style="width:355px">',N;

  // USER second serie

  if ( $ch['value']=='a' ) 
  {
  QTbarchart(QTarraymerge($arrA,$arrU[$intYear]),320,100,$intTopY,2,true,$L['Users_per_'.$ch['time']].' '.$intYear,'','3');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrU[$intYear])),350,100,$intTopY,2,'P',$L['Users_per_'.$ch['time']].' (%)'.' '.$intYear,'','3');
  }

  echo '</td>',N;
  echo '</tr></table>',N;

}
else
{
  echo '<p class="small">Graphs cannot be displayed because one of these files is missing: bin/qt_lib_graph.php, ',$_SESSION[QT]['skin_dir'].'/qti_main2.css</p>';
}

?>